// Dfinitions pour l'accs  ASYS7.DLL

// La structure passe en paramtre  AsysEntryPoint
#pragma pack(1)
#ifndef asys_packet
struct _asys_packet
	{
	WORD wCmd;			// Commande de ASYS  excuter
	WORD wClient;		// Numro de pile utilise (clients multiples)
	WORD wInst;			// Instance (excuteur multiples)
	WORD wAx;			// Les registres
	WORD wBx;
	WORD wCx;
	WORD wDx;
	LPVOID lpExtra;		// Permet d'changer des informations complmentaires
	};
#endif
#pragma pack()

// Les types de variables
#define VAR_I 0
#define VAR_O 1
#define VAR_B 2
#define VAR_T 3
#define VAR_C 4
#define VAR_M 5
#define VAR_F 6
#define VAR_L 7

// Les modes de marche
#define RUN 0
#define STOP 1
#define STEP 2
#define INIT 3

// Le message de requte unitaire
#define CLIENTWRITEONEMESS			11
// Les messages de requtes multiples
#define CLIENTINITSTACK				13 // raz pile
#define CLIENTPUSH					14 // empiler
#define CLIENTPOP					15 // dpiler
#define CLIENTCHECKSTACK			19 // pile traite ?
// Pour obtenir l'adresse des variables en mmoire
#define GETEXECUTOROPTIONS			131

// Le timout pour la rponse provenant d'un excuteur (em ms)
#define TIMOUT							10000


#ifdef __cplusplus
extern "C" BOOL ConnectToAsys(LPTSTR);
extern "C" void DeconnectAsys(void);
extern "C" BOOL IsExecutorAsys(void);
extern "C" BOOL ReadAsysEx(LPSTR var,BOOL bWaitAnswer,LPDWORD pdwResult,PWORD pwStatus);
extern "C" BOOL ReadAsys(BYTE cType,WORD wNum,BOOL bWaitAnswer,LPDWORD pdwResult,PWORD pwStatus);
extern "C" BOOL ReadAsysGetAnswer(LPDWORD pdwResult,PWORD pwStatus);
extern "C" BOOL WriteAsysEx(LPSTR var,BOOL bWaitAnswer,DWORD dwVal,PWORD pwStatus);
extern "C" BOOL WriteAsys(BYTE cType,WORD wNum,BOOL bWaitAnswer,DWORD dwVal,PWORD pwStatus);
extern "C" BOOL WriteAsysGetAnswer(PWORD pwStatus);
extern "C" BOOL ParseVarName(LPSTR var,PBYTE pbType,PWORD pwNumber);
extern "C" BOOL SetModeAsys(BYTE cMode,BOOL bWaitAnswer,PWORD pwStatus);
extern "C" BOOL SetModeAsysGetAnswer(PWORD pwStatus);
extern "C" void SetClient(WORD wClient);
extern "C" void SetInstance(WORD wInstance);
extern "C" void MultipleReadAsysInit(void);
extern "C" BOOL MultipleReadAsysPush(BYTE cType,WORD wNum,PWORD pwStatus);
extern "C" BOOL MultipleReadAsysPop(BYTE cType,PWORD pwStatus,PDWORD pdwResult);
extern "C" void MultipleReadAsysCheck(PWORD pwStatus);
extern "C" LPVOID GetSharedDataPointerAsys(BYTE cType,PWORD pwLen);
extern "C" WORD ReadSharedData(BYTE cType,WORD wNumber,DWORD *dwResult);
extern "C" WORD WriteSharedData(BYTE cType,WORD wNumber,DWORD dwVal);
extern "C" BOOL MultipleWriteAsysPop(BYTE cType,WORD wNum,PWORD pwStatus);
extern "C" BOOL MultipleWriteAsysPush(BYTE cType,WORD wNum,DWORD dwVal,PWORD pwStatus);
extern "C" void MultipleWriteAsysInit(void);
extern "C" void (*AsysEntryPoint)(struct _asys_packet *asys_packet);
extern "C" void MultipleWriteAsysCheck(PWORD pwStatus);
#else
BOOL ConnectToAsys(LPTsSTR);
void DeconnectAsys(void);
BOOL IsExecutorAsys(void);
BOOL ReadAsysEx(LPSTR var,BOOL bWaitAnswer,LPDWORD pdwResult,PWORD pwStatus);
BOOL ReadAsys(BYTE cType,WORD wNum,BOOL bWaitAnswer,LPDWORD pdwResult,PWORD pwStatus);
BOOL ReadAsysGetAnswer(LPDWORD pdwResult,PWORD pwStatus);
BOOL WriteAsysEx(LPSTR var,BOOL bWaitAnswer,DWORD dwVal,PWORD pwStatus);
BOOL WriteAsys(BYTE cType,WORD wNum,BOOL bWaitAnswer,DWORD dwVal,PWORD pwStatus);
BOOL WriteAsysGetAnswer(PWORD pwStatus);
BOOL ParseVarName(LPSTR var,PBYTE pbType,PWORD pwNumber);
BOOL SetModeAsys(BYTE cMode,BOOL bWaitAnswer,PWORD pwStatus);
BOOL SetModeAsysGetAnswer(PWORD pwStatus);
void SetClient(WORD wClient);
void SetInstance(WORD wInstance);
void MultipleReadAsysInit(void);
BOOL MultipleReadAsysPush(BYTE cType,WORD wNum,PWORD pwStatus);
BOOL MultipleReadAsysPop(BYTE cType,PWORD pwStatus,PDWORD pdwResult);
void MultipleReadAsysCheck(PWORD pwStatus);
LPVOID GetSharedDataPointerAsys(BYTE cType,PWORD pwLen);
WORD ReadSharedData(BYTE cType,WORD wNumber,DWORD *dwResult);
WORD WriteSharedData(BYTE cType,WORD wNumber,DWORD dwVal);
void (*AsysEntryPoint)(struct _asys_packet *asys_packet);
BOOL MultipleWriteAsysPop(BYTE cType,WORD wNum,PWORD pwStatus);
BOOL MultipleWriteAsysPush(BYTE cType,WORD wNum,DWORD dwVal,PWORD pwStatus);
void MultipleWriteAsysInit(void);
void MultipleWriteAsysCheck(PWORD pwStatus);
#endif

// Les fonctions issues de la version DOS
#define READWRITE3WORD				22
#define READWRITE128BYTES			23
#define EXECUTORISREADY				8
#define EXECUTORISSTOPPED			9
#define EXECUTORPROCESSMSG			10
#define CLIENTWRITEONEMESS			11
#define CLIENTSTOPEXECUTOR			12
#define CLIENTINITSTACK				13
#define CLIENTPUSH					14
#define CLIENTPOP					15
#define CLIENTCHECKSTACK			19
#define READWRITE3WORDNET			26


// Les nouvelles fonctions
#define EXECUTORGETOPTIONS			128		// retourne dans lpExtra un pointeur sur la zone 
#define GETASYSVERSION				129		// retourne le numro de version dans lpExtra : 00BBVVRRh : BB=bta, VV=version RR=release
#define EXECUTORPROGNAMECHANGE		130		// envoy par un excuteur pour donner le nom du programme 
#define GETEXECUTOROPTIONS			131		// envoy par un client pour connatre les caractristiques d'un excuteur : variables dans asys, etc ...
#define GETEXECUTORPROGNAME			132		// envoy par un client pour connatre le nom de l'application en cours d'excution
#define GETEXECUTORINFO				133		// envoy par excuteur ou un client pour connatre l'tat des excuteurs,en retour wCmd=nombre d'excuteur, lParam=installs ou pas (1 bit par excuteur)
#define EXECUTORIDCHANGE			134		// envoy par un excuteur pour donner son nom gnrique
#define GETEXECUTORID				135		// envoy par un client pour connatre le nom gnrique d'un excuteur
#define GETVVADR					136		// retourne l'adresse des variables virtuelles dans lpExtra
#define GETINTERNALSTRUCT			137		// retourne les adresses des variables internes  asys
#define LOADEXECUTOR				138		// installe un excuteur lpExtra donne le nom en entre, lpExtraData retourne le handle de process en sortie
#define EXECUTORISREADY16			139		// envoy par un excuteur 16 bits pour signaler qu'il est prt  traiter des messages

#define READSHAREDDATA				140		// envoy par un client pour lire les donnes partage
#define WRITESHAREDDATA				141		// envoy par un client pour crire les donnes partage