// Programme illustrant l'utilisation du dialogue avec la base de donnes d'AUTOMGEN V7


#include "windows.h"
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include "a7com.h"


void readvar(void)
{
char name[32];
BYTE cType;
WORD wNum;
// Saisir le nom de la variable
printf("Nom de la variable :");
fgets(name,31,stdin);
name[strlen(name)-1]=0; // Supprimer le cr de fin de chane
if(ParseVarName(name,&cType,&wNum))
	{ // Nom de la variable ok
	do
		{
		DWORD dwResult;
		WORD wStatus;
		// Lire l'tat
		if(ReadAsys(cType,wNum,TRUE,&dwResult,&wStatus))
			{
			switch(cType)
				{ 
				// Variables boolennes
				case VAR_I : 
				case VAR_O : 
				case VAR_B : 
					{
					printf("Status=%4.4X, Etat=%u\n",wStatus,dwResult);
					} break;
				// Variables numriques 16 bits
				case VAR_M : 
				case VAR_C : 
					{
					printf("Status=%4.4X, Etat=%4.4X\n",wStatus,dwResult);
					} break;
				// Temporisations
				case VAR_T : 
					{
					printf("Status=%4.4X, Consigne=%u, Compteur=%u\n",wStatus,HIWORD(dwResult),LOWORD(dwResult));
					} break;
				// Variables numriques 32 bits
				case VAR_L : 
					{
					printf("Status=%4.4X, Etat=%8.8lx\n",wStatus,dwResult);
					} break;
				// Variables relles
				case VAR_F :
					{
					PWORD pw=&(WORD)dwResult;
					double db;
					float *pf=&(float)dwResult;
					WORD w;
					// Inverser poids faibles et poids forts
					w=pw[0];
					pw[0]=pw[1];
					pw[1]=w;
					db=*pf;
					printf("Status=%4.4X, Etat=%f\n",wStatus,db);
					} break;
				}
			}
		else 
			{
			printf("Erreur a la lecture\n");
			break;
			}
		}
	while(!kbhit());
	while(kbhit()) getch();
	}
else printf("Nom invalide\n");
}

// Lecture de 6 variables

void readmultiplevar(void)
{
char name[32];
BYTE cType;
WORD wNum;
// Saisir le nom de la variable
printf("Nom de la variable :");
fgets(name,31,stdin);
name[strlen(name)-1]=0; // Supprimer le cr de fin de chane
if(ParseVarName(name,&cType,&wNum))
	{ // Nom de la variable ok
	do
		{
		unsigned count;
		DWORD dwResult;
		DWORD dwTime;
		WORD wStatus;
		// Initialiser la pile
		MultipleReadAsysInit();
		// Empiler les demandes
		for(count=0;count<6;count++)
			{
			if(!MultipleReadAsysPush(cType,(WORD)(wNum+count),&wStatus))
				{
				printf("Erreur %4.4X au push\n",wStatus);
				return;
				}
			}
		// Attendre la fin du traitement (pas plus de 1000 ms)
		dwTime=GetTickCount();
		do
			{
			MultipleReadAsysCheck(&wStatus);
			if(wStatus==0) break; // Ok, pile traite
			if(GetTickCount()-dwTime>1000) 
				{
				printf("Timout\n");
				return;
				}
			}
		while(1);
		// Dpiler
		for(count=0;count<6;count++)
			{
			if(!MultipleReadAsysPop(cType,&wStatus,&dwResult))
				{
				printf("Erreur %4.4X au pop\n",wStatus);
				return;
				}
			switch(cType)
				{ 
				// Variables boolennes
				case VAR_I : 
				case VAR_O : 
				case VAR_B : 
					{
					printf("%u ",dwResult);
					} break;
				// Variables numriques 16 bits
				case VAR_M : 
				case VAR_C : 
					{
					printf("%4.4X ",dwResult);
					} break;
				// Temporisations
				case VAR_T : 
					{
					printf("%u,%u ",HIWORD(dwResult),LOWORD(dwResult));
					} break;
				// Variables numriques 32 bits
				case VAR_L : 
					{
					printf("%8.8lx ",dwResult);
					} break;
				// Variables relles
				case VAR_F :
					{
					PWORD pw=&(WORD)dwResult;
					double db;
					float *pf=&(float)dwResult;
					WORD w;
					// Inverser poids faibles et poids forts
					w=pw[0];
					pw[0]=pw[1];
					pw[1]=w;
					db=*pf;
					printf("%f ",db);
					} break;
				}
			}
		printf("\n");
		}
	while(!kbhit());
	while(kbhit()) getch();
	}
else printf("Nom invalide\n");
}


void writevar(void)
{
char name[32];
char cste[128];
BYTE cType;
WORD wNum;
// Saisir le nom de la variable
printf("Nom de la variable :");
fgets(name,31,stdin);
name[strlen(name)-1]=0; // Supprimer le cr de fin de chane
if(ParseVarName(name,&cType,&wNum))
	{ // Nom de la variable ok
	DWORD dwVal;
	WORD wStatus;
	// Saisir la constante (aucun contrle sur la validit de la constante n'est ralis dans cet exemple)
	printf("Constante :");
	fgets(cste,127,stdin);
	cste[strlen(cste)-1]=0; // Supprimer le cr de fin de chane
	// Convertir
	switch(cType)
		{ 
		// Variables boolennes
		case VAR_I : 
		case VAR_O : 
		case VAR_B : 
			{
			dwVal=atoi(cste)?1:0;
			} break;
		// Variables numriques 16 bits
		case VAR_T : // (consigne)
		case VAR_M : 
		case VAR_C : 
			{
			dwVal=atoi(cste);
			} break;
		// Variables numriques 32 bits
		case VAR_L : 
			{
			dwVal=atol(cste);
			} break;
		// Variables relles
		case VAR_F :
			{
			PWORD pw=&(WORD)dwVal;
			double db;
			float *pf=&(float)dwVal;
			db=atof(cste);
			*pf=(float)db;
			} break;
		}
	// Ecrire l'tat
	if(WriteAsys(cType,wNum,TRUE,dwVal,&wStatus))
		{
		printf("Ecriture effectuee : status=%4.4X\n",wStatus);
		}
	else 
		{
		printf("Erreur a la l'ecriture\n");
		}
	}
else printf("Nom invalide\n");
}

void dump(void)
{
LPBYTE lp;
unsigned count;
int adr=0;
WORD wLen;
WORD wNum;
BYTE cType;
char name[32];
// Saisir le nom de la variable
printf("Nom de la variable :");
fgets(name,31,stdin);
name[strlen(name)-1]=0; // Supprimer le cr de fin de chane
if(!ParseVarName(name,&cType,&wNum))
	{
	printf("Nom incorrect\n");
	return;
	}
// Rcuprer l'adresse de stockage des variables
lp=GetSharedDataPointerAsys(cType,&wLen);
if(lp==NULL)
	{
	printf("Pas de variable en memoire\n");
	return;
	}
do
	{
	COORD c;
	c.X=1;
	c.Y=1;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),c);
	for(count=0;count<256;count++)
		{
		if((count&15)==0)
			{
			printf("\n%4.4X : ",adr+count);
			}
		if(adr+count<wLen)
			{
			printf("%2.2X ",lp[adr+count]);
			}
		else
			{
			printf("   ");
			}
		}	
	if(kbhit())
		{
		switch(getch())
			{
			case 0 : getch(); break;
			case '+' : adr+=256; break;
			case '-' : adr-=256; break;
			default : return;
			}
		if(adr>wLen-256) adr=wLen-256;
		if(adr<0) adr=0;
		}
	}
while(1);
}

void main(void)
{
// Connexion  la base de donnes
if(!ConnectToAsys(NULL))
	{
	// Connexion  ASYS7.DLL : impossible : ASYS7.DLL probablement pas trouv 
	exit(-1);
	}
// Vrifier qu'un excuteur est install
if(!IsExecutorAsys())
	{
	// Pas d'excuteur install
	// Dconnecter
	DeconnectAsys();
	exit(-2);
	}
do
	{
	// Le menu
	printf("\nMenu\n");
	printf("1- Lire l'etat d'une variable\n");
	printf("2- Ecrire l'etat d'une variable\n");
	printf("3- Lire l'etat d'une table de variables\n");
	printf("4- mode RUN\n");
	printf("5- mode STOP\n");
	printf("6- INIT\n");
	printf("7- dumper la memoire des variables (accs direct)\n");
	printf("8- Quitter\n");
	switch(getch())
		{
		case 0 : // Touche tendue :  enlever le caractre supplmentaire
			{
			getch();
			}
			break;
		case '1' : // Lire l'tat d'une variable
			{
			readvar();
			} break;
		case '2' : // Ecrire l'tat d'une variable
			{
			writevar();
			} break;
		case '3' : // Lire l'tat d'une table de variables
			{
			readmultiplevar();
			} break;
		case '4' : // RUN
			{
			WORD wStatus;
			if(SetModeAsys(RUN,TRUE,&wStatus))
				{
				printf("Ok : status=%4.4X",wStatus);
				}
			else
				{
				printf("Erreur");
				}
			} break;
		case '5' : // STOP
			{
			WORD wStatus;
			if(SetModeAsys(STOP,TRUE,&wStatus))
				{
				printf("Ok : status=%4.4X",wStatus);
				}
			else
				{
				printf("Erreur");
				}
			} break;
		case '6' : // INIT
			{
			WORD wStatus;
			if(SetModeAsys(INIT,TRUE,&wStatus))
				{
				printf("Ok : status=%4.4X",wStatus);
				}
			else
				{
				printf("Erreur");
				}
			} break;
		case '7' : // Dump
			{
			dump();
			} break;
		case '8' : // Quitter
			{
			DeconnectAsys();
			exit(0);
			}
		}
	}
while(1);
}

